require "net/http"
require "uri"
require "json"

class Instance
    attr_reader :id
    def initialize(raw)
        @id = raw["id"]
    end
end

class Bot

    @@HOST = "https://mebotsco.herokuapp.com"
    @@API_ROOT = "/api/"

    def initialize(slug, token)
        @slug = slug
        @token = token
    end

    def get(endpoint)
        uri = URI(@@HOST + @@API_ROOT + endpoint + "?token=#{@token}")

        Net::HTTP.start(uri.host, uri.port,
            :use_ssl => uri.scheme == "https") do |http|
            req = Net::HTTP::Get.new(uri)

            return JSON.parse(http.request(req).body)
        end
    end

    def instance(group_id)
        return Instance.new(get("bot/#{@slug}/instance/#{group_id}"))
    end
end
